{* This program demonstrates the use of Computer One standard
   Pascal for the Sinclair QL. In particular this tests the sound
   system of the QL.  There is one procedure of interest to all 
   standard Pascal programmers, that is the procedure converting
   a "string" into an integer. One of the basic tasks of standard
   Pascal programming. You'll also notice one snag with having my
   source code.  I use Finnish variable and routine names *}

program beeptester;
{          1234567890123456789012345678901234567}
const ohj='BEEPTESTER                           ';
      tpvm='26.01.86';
      n=8;      {parameters}
      ppit=8;   {param name max length}
      cpit=37;  {to clear a row}
      mjpit=37; {srting length}
      brd=0;    {border width}
type  pjono=array [1..ppit] of char;
      ptaul=array [1..n] of pjono;
      ataul=array [1..n] of integer;
      mjono=array [1..mjpit] of char;
      mjono8=array [1..8] of char;
var   para : ptaul;
      ala, yla
      ,a          {parameter values}
       : ataul;
      pit
      ,errn
      ,kokoaika
      ,i
      ,p,key
      ,arvo
       : integer;
      con : text;

{* Open the screen *}
procedure OPENCON;
begin
 mode(8);
 attach(con,'con_'); rewrite(con);
 window(con,513,256,0,0);
 paper(con,black,black,0);
 cls(con,0);
 window(con,448,200,32,16);
 paper(con,blue,blue,0);
 ink(con,white,white,0);
 border(con,brd,green,black,3);
 cls(con,0);
end;

{* Length of a "string" *}
function LEN(m:mjono):integer;
var il:integer;
begin
 len:=0;
 for il:=1 to mjpit do if ord(m[il])>32 then
  len:=il;
end;

{* Continue: press enter *}
procedure ENTJATK;
var chl:char;
begin
 chl:='*';
 while (ord(chl)<>10) or (errn<>0) do
  begin
   cursor(con,0,180-2*brd);cls(con,2);
   cursor(con,0,190-2*brd);
   write(con,'CONTINUE: PRESS ENTER? ');
   pit:=getline(con,1,loc(chl));
   errn:=ioresult;
  end;
end;

{* PASCAL logo *}
procedure PASLOGO(ohj:mjono;tpvm:mjono8);
var il:integer;
begin
 csize(con,3,1);ink(con,white,white,0);
 cursor(con,224-8*10,60);write(con,'Timo Salmi');
 ink(con,black,black,0);cursor(con,224-8*15,80);
 write(con,'PASCAL PROGRAMS');
 ink(con,yellow,yellow,0);
 cursor(con,224-8*LEN(ohj),120);
 for il:=1 to LEN(ohj) do write(con,ohj[il]);
 csize(con,2,0);ink(con,cyan,cyan,0);
 cursor(con,222-6*8,100);write(con,tpvm);
 ink(con,white,white,3);
 ENTJATK;
end; 

{* Initial values *}
procedure ALKUASET;
var i : integer;
begin
 para[4]:='DURATION'; ala[4]:=-32768;
  yla[4]:=32767; a[4]:=100;
 para[1]:='PITCH1  '; ala[1]:=0;
  yla[1]:=255;   a[1]:=0;
 para[2]:='PITCH2  '; ala[2]:=0;
  yla[2]:=255;   a[2]:=0;
 para[6]:='WRAP    '; ala[6]:=0;
  yla[6]:=15;    a[6]:=0;
 para[3]:='INTERVAL'; ala[3]:=0;
  yla[3]:=15;    a[3]:=0;
 para[5]:='STEP    '; ala[5]:=-8;
  yla[5]:=7;     a[5]:=0;
 para[8]:='FUZZY   '; ala[8]:=0;
  yla[8]:=15;    a[8]:=0;
 para[7]:='RANDOM  '; ala[7]:=-32768;
  yla[7]:=32767; a[7]:=0;
end;

{* Display the settings *}
procedure NAYTA(i:integer);
var r,j : integer;
begin
 r:=i;
 at(con,r,0); ink(con,white,white,3);
 for j:=1 to cpit do write(con,' ');
 at(con,r,0); write(con,i:1);
 at(con,r,2); write(con,para[i]);
 ink(con,black,black,3);
 at(con,r,11); write(con,ala[i]:6);
 at(con,r,18); write(con,yla[i]:5);
 ink(con,white,white,3);
 at(con,r,26); write(con,a[i]:6);
end;

{* Alternatives *}
procedure VEHDOT;
begin
 at(con,10,0); ink(con,white,white,3);
 writeln(con,'ALTER: 1-8, BEEP: space bar');
 writeln(con,'TO EXIT: ESC');
end;

{* Choice *}
procedure VALINTA (var key:integer);
var i : integer;
    cl : char;
begin
 repeat
  cl:='*';
  pit:=getbytes(con,1,loc(cl));
  errn:=ioresult;
  i:=ord(cl);
 until (((i>=49)and(i<=56))or(i=32)or(i=27)) and (errn=0);
 key:=i;
end;

{* Convert a string to an integer *}
procedure INTVAL(mj:mjono;var luku:integer;
          var ok:boolean);
var il,lenl:integer;
    nrol:boolean;
begin
 ok:=true;
 lenl:=LEN(mj);
 if lenl=0 then ok:=false;
 if mj[1]<>'-' then
  begin if lenl>9 then ok:=false end 
   else if lenl>10 then ok:=false;
 for il:=2 to mjpit do 
  if mj[il]='-' then ok:=false;
 for il:=1 to lenl do
  if not(mj[il] in ['0'..'9','-']) then 
   ok:=false;
 nrol:=false;
 for il:=1 to lenl do
  if mj[il] in ['0'..'9'] then nrol:=true;
 if nrol=false then ok:=false;
 if ok then
  begin
   luku:=0;
   for il:=1 to lenl do
    if mj[il]<>'-' then
     luku:=(ord(mj[il])-48)+10*luku;
   if mj[1]='-' then luku := -luku;
  end;
end;

{* Ask for user's input *}
procedure KYSY(p:integer; var arvo:integer);
var vast : mjono;
    ok   : boolean;
    r,j  : integer;
begin
 r:=12;
 at(con,r,0); cls(con,2);
 repeat
  at(con,r+1,0); ink(con,white,white,3);
  for j:=1 to cpit do write(con,' ');
  at(con,r+1,0);
  write(con,para[p],' ');
  write(con,'GIVE NEW VALUE? ');
  for j:=1 to mjpit do vast[j]:=' ';
  pit:=getline(con,mjpit,loc(vast));
  errn:=ioresult;
  cls(con,2);
  INTVAL (vast,arvo,ok);
  if not ok then
   begin 
    ink(con,red,red,3);
    writeln(con,'INVALID INTEGER');
   end
  else
   begin 
    at(con,r,0);
    cls(con,2);
   end;
 until ok and (errn=0);
end;

{* It is ready *}
procedure VALMIS;
var tl,ml,sl:integer;
begin
 write(con,'READY, elapsed ');
 sl:=readclock-kokoaika;
 tl:=sl div 3600; sl:=sl mod 3600;
 ml:=sl div 60; sl:=sl mod 60;
 if tl>0 then write(con,tl:2,' h ');
 if ml>0 then write(con,ml:2,' min ');
 writeln(con,sl:2,' sec');
end;

{* Main program *}
begin
 kokoaika:=readclock;
 OPENCON;
 PASLOGO(ohj,tpvm);
 ALKUASET;
 cls(con,0);
 for i:=1 TO n do NAYTA(i);
 VEHDOT;
 repeat
  VALINTA(key);
  if (key<>27) then
   begin 
    if (key=32) then 
     beep(a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8])
    else
     begin 
      p:=key-48;
      KYSY(p,arvo);
      a[p]:=arvo;
      NAYTA(p);
     end;
   end; 
 until (key=27);
 at(con,12,0);
 VALMIS;
 close(con);
end.
